/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_LOCALEMISSAO                                             */
/* Tabela : LOCALEMISSAO                                                      */
/*                                                                            */
/* Criao:                                                                   */
/* 23/01/2004 - Newton N. Santos                                              */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_LOCALEMISSAO
BEFORE INSERT OR UPDATE OR DELETE
ON LOCALEMISSAO FOR EACH ROW 

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATULOEM := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDLOCALEMIS,0)  <> NVL(:NEW.CDLOCALEMIS,0)) OR
         (NVL(:OLD.DSLOCALEMIS,0)  <> NVL(:NEW.DSLOCALEMIS,0)) OR
         (NVL(:OLD.CDRELMODNFLO,0) <> NVL(:NEW.CDRELMODNFLO,0)) OR
         (NVL(:OLD.DTULTEMISLCE,TO_DATE('31/12/1899','DD/MM/YYYY')) <>  NVL(:NEW.DTULTEMISLCE,TO_DATE('31/12/1899','DD/MM/YYYY'))) THEN
         :NEW.DTULTATULOEM := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('LOCALEMISSAO', '', 'CDLOCALEMIS='||:OLD.CDLOCALEMIS||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE LOCALEMISSAO MODIFY DTULTATULOEM DEFAULT SYSDATE
/
