/* Sistemas Integrados TEKNISA
   Compras e Suprimentos

Nome: 8420_SUPSTPS.sql

Descrio:
Projeo de estoque dirio para o operador logstico

Criao:
11/07/2006 - Marcelo Alexsandro Souza Silva
*/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'PROJETA_ESTOQUE_DIA'  and
            type = 'P'                  and
            u.uid = o.uid               and
            u.name = USER)
DROP PROCEDURE PROJETA_ESTOQUE_DIA
GO
CREATE PROCEDURE PROJETA_ESTOQUE_DIA(@P_CDFILIAL     VARCHAR(4),
                                     @P_DTLEVINI     DATETIME,
                                     @P_DTLEVFIN     DATETIME,
                                     @P_PRODINI      VARCHAR(20),
                                     @P_PRODFIN      VARCHAR(20),
                                     @P_ENTRINI      DATETIME,
                                     @P_ENTRFIN      DATETIME,
                                     @P_SAIDAINI     DATETIME,
                                     @P_SAIDAFIN     DATETIME,
                                     @P_NRSEQESTPROJ VARCHAR(10) OUTPUT)
AS
   DECLARE @V_NRESTPROJET VARCHAR(20);
   DECLARE @V_QTESTOQANT  NUMERIC(15,5);
   DECLARE @V_QTESTOQUE   NUMERIC(15,5);
   DECLARE @V_ESTOQFILI   NUMERIC(15,5);
   DECLARE @V_RESERVAESTOQUE NUMERIC(15,5);
   DECLARE @V_IDUTILDTPROC VARCHAR(1);
   DECLARE @V_DATAPROC DATETIME;
   DECLARE @V_COUNT INT;
   DECLARE @V_QTPROJESTPRO NUMERIC(15,5);
   DECLARE @V_PRODUTO_CDPRODESTO VARCHAR(10);
   DECLARE @V_FILIAL_CDFILIAL VARCHAR(4);

   DECLARE @V_AFPEND_CDPRODESTO VARCHAR(10)
   DECLARE @V_AFPEND_QTAFPEND NUMERIC(15,5);

   DECLARE @V_PEDIDO_CDPRODESTO VARCHAR(10);
   DECLARE @V_PEDIDO_QTPEDIDO   NUMERIC(15,5);

   DECLARE @V_DATA_DTDATA DATETIME;

   DECLARE @V_ITEMAUTF_CDPRODESTO VARCHAR(10);
   DECLARE @V_ITEMAUTF_QTPROGENTAF NUMERIC(15,5)

   DECLARE @V_SAIDA_CDPRODESTO VARCHAR(10);
   DECLARE @V_SAIDA_QTAENTREGAR NUMERIC(15,5);

   DECLARE @V_PROD_CDFILESTPROJ VARCHAR(4);
   DECLARE @V_PROD_NRSEQESTPROJ VARCHAR(10);
   DECLARE @V_PROD_CDPROESTPROJ VARCHAR(10)
   DECLARE @V_PROD_DTENTESTPROJ DATETIME;

   DECLARE @V_NOVO_CODIGO VARCHAR(20);
   DECLARE C_FILIAL CURSOR FOR
   SELECT
      CDFILIAL
   FROM
      FILIAL
   WHERE
      CDFILIAL = @P_CDFILIAL;
      
   DECLARE @V_QTDAF NUMERIC(15,5);
   DECLARE @V_QTDSOL NUMERIC(15,5);
   DECLARE @V_VDOL   VARCHAR(1); -- Verifica se a filial  operador logistico ou no
BEGIN
   SELECT
      @V_IDUTILDTPROC = MAX(IDUTILDTPROC)
   FROM
      PARAMGERAL;
   IF @V_IDUTILDTPROC <> 'S' BEGIN
      SET @V_DATAPROC = CONVERT(DATETIME, GETDATE(), 103);
   END
   ELSE BEGIN
      SELECT
         @V_DATAPROC = ISNULL(MAX(DTPROCESSA), CONVERT(DATETIME, GETDATE(), 103))
      FROM
         PARAMFILIAL
      WHERE
         CDFILIAL = @P_CDFILIAL;
   END;
   
   SELECT @V_VDOL = ISNULL(F.IDFUNCAOFILI, 'N')
   FROM FILIAL F
   WHERE F.CDFILIAL = @P_CDFILIAL;
   
   SET @V_NRESTPROJET = NULL;
   SET @V_NOVO_CODIGO = 'TRAB_ESTPROJET' + @P_CDFILIAL;
   EXEC NOVO_CODIGO @V_NOVO_CODIGO, @P_SEQUENCIAL = @V_NRESTPROJET OUTPUT, @P_QTDE = 1;
   SET @P_NRSEQESTPROJ = SUBSTRING(@V_NRESTPROJET, 11, 10);

   /*Estoque na data inicial do perodo*/
   DECLARE C_PRODUTO CURSOR FOR
      SELECT DISTINCT
          PRODUTO.CDPRODESTO
       FROM
          PRODUTO
       WHERE
          PRODUTO.CDARVPROD  BETWEEN @P_PRODINI AND @P_PRODFIN AND
          CDPRODESTO IS NOT NULL;
   OPEN C_PRODUTO;
   FETCH NEXT FROM C_PRODUTO INTO @V_PRODUTO_CDPRODESTO;
   WHILE (@@FETCH_STATUS = 0)
   BEGIN
      SET @V_QTESTOQUE      = 0;
      SET @V_ESTOQFILI      = 0;
      SET @V_QTESTOQANT     = 0;
      SET @V_RESERVAESTOQUE = 0;
      OPEN C_FILIAL;
      FETCH NEXT FROM C_FILIAL INTO @V_FILIAL_CDFILIAL;
      WHILE (@@FETCH_STATUS = 0)
      BEGIN
         SET @V_ESTOQFILI = 0;

         SET @V_ESTOQFILI = TEKNISA.CALC_ESTOQ_CONS(@V_FILIAL_CDFILIAL, @V_PRODUTO_CDPRODESTO, @P_DTLEVINI + 1);

/*       SELECT
            @V_RESERVAESTOQUE = SUM(QTRESERVESTOL)
         FROM
            RESERVAPEDEXOL
         WHERE CDFILRESOL = @P_CDFILIAL
           AND DTRESEMBARQ = @P_DTLEVINI
           AND EXISTS (SELECT 1
                       FROM RELACPRODOL
                       WHERE RELACPRODOL.CDPRODARVOL = @V_PRODUTO_CDPRODESTO
                         AND RELACPRODOL.CDPRARVORIG = RESERVAPEDEXOL.CDPRODUTO
                         AND RELACPRODOL.CDMARCA     = RESERVAPEDEXOL.CDMARCA);

         IF (@V_RESERVAESTOQUE IS NULL) BEGIN
            SET @V_RESERVAESTOQUE = 0;
         END;*/

         SET @V_QTESTOQUE = @V_QTESTOQUE + @V_ESTOQFILI - @V_RESERVAESTOQUE;
         FETCH NEXT FROM C_FILIAL INTO @V_FILIAL_CDFILIAL;
      END;
      CLOSE C_FILIAL;
      IF @V_QTESTOQUE > 0 BEGIN
         INSERT INTO TRAB_ESTPROJET
            (CDFILESTPROJ,
             NRSEQESTPROJ,
             CDPROESTPROJ,
             QTPRODESTOQ,
             QTPROJESTPRO,
             DTENTESTPROJ)
         VALUES
            (@P_CDFILIAL,
             SUBSTRING(@V_NRESTPROJET,11,10),
             @V_PRODUTO_CDPRODESTO,
             ISNULL(@V_QTESTOQUE, 0),
             ISNULL(@V_QTESTOQUE, 0),
             @P_DTLEVINI);
      END;
      FETCH NEXT FROM C_PRODUTO INTO @V_PRODUTO_CDPRODESTO;
   END;
   CLOSE C_PRODUTO;
   DEALLOCATE C_PRODUTO;

   /* Entrada de Produto do OL -  AF's pendentes */
   DECLARE C_AFPEND CURSOR FOR
      SELECT
         PRODUTO.CDPRODESTO,
         ISNULL(SUM((QTPROGENTAF - ISNULL(QTEFETENTRAF,0)) * PRODUTO.VRFATOCONV), 0) QTAFPEND
      FROM
         PRODUTO,
         ITEMAUTF
      WHERE ITEMAUTF.CDFILDEST = @P_CDFILIAL
        AND ITEMAUTF.CDPRODUTO = PRODUTO.CDPRODUTO
        AND PRODUTO.CDARVPROD BETWEEN @P_PRODINI AND @P_PRODFIN
        AND DTPROGENTAF BETWEEN ISNULL(@P_ENTRINI, @V_DATAPROC) AND ISNULL(@P_ENTRFIN, @P_DTLEVINI-1)
        AND (ITEMAUTF.IDBAIXITMAF IS NULL OR ITEMAUTF.IDBAIXITMAF = '1')
        AND NOT EXISTS
               (SELECT
                   '1'
                FROM
                   AUTOFORNE
                WHERE
                   AUTOFORNE.CDFILLANC  = ITEMAUTF.CDFILLANC AND
                   AUTOFORNE.CDFILDEST  = ITEMAUTF.CDFILDEST AND
                   AUTOFORNE.NRAUTOFORN = ITEMAUTF.NRAUTOFORN AND
                   AUTOFORNE.IDBAIXAAF  IN('4','5','6'))
      GROUP BY
         PRODUTO.CDPRODESTO;
   OPEN C_AFPEND;
   FETCH NEXT FROM C_AFPEND INTO @V_AFPEND_CDPRODESTO, @V_AFPEND_QTAFPEND;
   WHILE (@@FETCH_STATUS = 0)
   BEGIN
      SET @V_QTESTOQUE      = 0;
      SET @V_ESTOQFILI      = 0;
      SET @V_QTESTOQANT     = 0;
      SET @V_RESERVAESTOQUE = 0;
      UPDATE TRAB_ESTPROJET
      SET QTPRODLANCAF = ISNULL(QTPRODLANCAF, 0) + @V_AFPEND_QTAFPEND,
          QTPROJESTPRO = ISNULL(QTPROJESTPRO, 0) + @V_AFPEND_QTAFPEND
      WHERE
         CDFILESTPROJ = @P_CDFILIAL                     AND
         NRSEQESTPROJ = SUBSTRING(@V_NRESTPROJET,11,10) AND
         CDPROESTPROJ = @V_AFPEND_CDPRODESTO            AND
         DTENTESTPROJ = @P_DTLEVINI;
      IF (@@ROWCOUNT = 0) BEGIN
         SELECT
            @V_QTESTOQANT = MAX(QTPROJESTPRO)
         FROM
            TRAB_ESTPROJET
         WHERE
            CDFILESTPROJ = @P_CDFILIAL                      AND
            NRSEQESTPROJ = SUBSTRING(@V_NRESTPROJET,11,10)  AND
            CDPROESTPROJ = @V_AFPEND_CDPRODESTO             AND
            DTENTESTPROJ = @P_DTLEVINI;
         IF @V_QTESTOQANT IS NOT NULL BEGIN
            SET @V_QTESTOQUE = @V_QTESTOQUE + @V_QTESTOQANT;
         END
         ELSE BEGIN
            OPEN C_FILIAL;
            FETCH NEXT FROM C_FILIAL INTO @V_FILIAL_CDFILIAL;
            WHILE (@@FETCH_STATUS = 0)
            BEGIN
               SET @V_ESTOQFILI = 0;
               SET @V_ESTOQFILI = TEKNISA.CALC_ESTOQ_CONS(@V_FILIAL_CDFILIAL, @V_AFPEND_CDPRODESTO, @P_DTLEVINI+1);

/*             SELECT
                  @V_RESERVAESTOQUE = SUM(QTRESERVESTOL)
               FROM
                  RESERVAPEDEXOL
               WHERE CDFILRESOL = @P_CDFILIAL
                 AND DTRESEMBARQ = @P_DTLEVINI
                 AND EXISTS (SELECT 1
                             FROM RELACPRODOL
                             WHERE RELACPRODOL.CDPRODARVOL = @V_AFPEND_CDPRODESTO
                               AND RELACPRODOL.CDPRARVORIG = RESERVAPEDEXOL.CDPRODUTO
                               AND RELACPRODOL.CDMARCA     = RESERVAPEDEXOL.CDMARCA);

               IF (@V_RESERVAESTOQUE IS NULL) BEGIN
                  SET @V_RESERVAESTOQUE = 0;
               END;*/

               SET @V_QTESTOQUE = @V_QTESTOQUE + @V_ESTOQFILI - @V_RESERVAESTOQUE;
               FETCH NEXT FROM C_FILIAL INTO @V_FILIAL_CDFILIAL;
            END;
            CLOSE C_FILIAL;
         END;
         INSERT INTO TRAB_ESTPROJET
            (CDFILESTPROJ,
             NRSEQESTPROJ,
             CDPROESTPROJ,
             QTPRODESTOQ,
             QTPRODLANCAF,
             QTPROJESTPRO,
             DTENTESTPROJ)
         VALUES
            (@P_CDFILIAL,
             SUBSTRING(@V_NRESTPROJET,11,10),
             @V_AFPEND_CDPRODESTO,
             ISNULL(@V_QTESTOQUE, 0),
             @V_AFPEND_QTAFPEND,
             ISNULL(@V_QTESTOQUE, 0) + @V_AFPEND_QTAFPEND,
             @P_DTLEVINI);
      END;
      FETCH NEXT FROM C_AFPEND INTO @V_AFPEND_CDPRODESTO, @V_AFPEND_QTAFPEND;
   END;
   CLOSE C_AFPEND;
   DEALLOCATE C_AFPEND;

   /* Saida de Produto do OL -  Pedidos do OL pendentes */
   DECLARE C_PEDIDOOLPEND CURSOR FOR
      SELECT
        PRODUTO.CDPRODESTO,
        SUM(ISNULL(ITEMPEDEXOL.QTATENDPEDOL, ITEMPEDEXOL.QTPROGENPEOL)) AS QTPEDIDOOL
      FROM
         PRODUTO,
         ITEMPEDEXOL,
         PEDIDOEXOL,
         RELACPRODOL
      WHERE ITEMPEDEXOL.CDFILDEST     = PEDIDOEXOL.CDFILDEST
        AND ITEMPEDEXOL.CDFILLANC     = PEDIDOEXOL.CDFILLANC
        AND ITEMPEDEXOL.NRPEDEXOL     = PEDIDOEXOL.NRPEDEXOL
        AND RELACPRODOL.CDPRODARVOL   = PRODUTO.CDPRODUTO
        AND ITEMPEDEXOL.CDMARCA       = RELACPRODOL.CDMARCA
        AND ITEMPEDEXOL.CDPRODUTO     = RELACPRODOL.CDPRARVORIG
        AND ISNULL(PEDIDOEXOL.IDBAIXEXOL, '0') NOT IN ('4', '5')
        AND PEDIDOEXOL.CDFILIOPELOG   = @P_CDFILIAL
        AND PRODUTO.CDARVPROD  BETWEEN  @P_PRODINI  AND @P_PRODFIN
        AND ITEMPEDEXOL.IDBAIXAOLSAI IS NULL
        AND ISNULL(ITEMPEDEXOL.QTATENDPEDOL, 1) > 0
        AND ITEMPEDEXOL.DTPROGEMBARQ BETWEEN ISNULL(@P_SAIDAINI, @V_DATAPROC) AND ISNULL(@P_SAIDAFIN, @P_DTLEVINI-1)
      GROUP BY CDPRODESTO;
   OPEN C_PEDIDOOLPEND;
   FETCH NEXT FROM C_PEDIDOOLPEND INTO @V_PEDIDO_CDPRODESTO, @V_PEDIDO_QTPEDIDO;
   WHILE (@@FETCH_STATUS = 0) BEGIN
      SET @V_QTESTOQUE      = 0;
      SET @V_ESTOQFILI      = 0;
      SET @V_QTESTOQANT     = 0;
      SET @V_RESERVAESTOQUE = 0;
      UPDATE TRAB_ESTPROJET
      SET QTPRODSOLI = ISNULL(QTPRODSOLI, 0) + @V_PEDIDO_QTPEDIDO,
          QTPROJESTPRO = ISNULL(QTPROJESTPRO, 0) - @V_PEDIDO_QTPEDIDO
      WHERE
         CDFILESTPROJ = @P_CDFILIAL                    AND
         NRSEQESTPROJ = SUBSTRING(@V_NRESTPROJET,11,10) AND
         CDPROESTPROJ = @V_PEDIDO_CDPRODESTO           AND
         DTENTESTPROJ = @P_DTLEVINI;
      IF (@@ROWCOUNT = 0) BEGIN
         SELECT
            @V_QTESTOQANT = MAX(QTPROJESTPRO)
         FROM
            TRAB_ESTPROJET
         WHERE
            CDFILESTPROJ = @P_CDFILIAL                     AND
            NRSEQESTPROJ = SUBSTRING(@V_NRESTPROJET,11,10) AND
            CDPROESTPROJ = @V_PEDIDO_CDPRODESTO            AND
            DTENTESTPROJ = @P_DTLEVINI;
         IF @V_QTESTOQANT IS NOT NULL BEGIN
            SET @V_QTESTOQUE = @V_QTESTOQUE + @V_QTESTOQANT;
         END
         ELSE BEGIN
            SET @V_ESTOQFILI = 0;
            SET @V_ESTOQFILI = TEKNISA.CALC_ESTOQ_CONS(@V_FILIAL_CDFILIAL, @V_AFPEND_CDPRODESTO, @P_DTLEVINI+1);

/*          SELECT
               @V_RESERVAESTOQUE = SUM(QTRESERVESTOL)
            FROM
               RESERVAPEDEXOL
            WHERE CDFILRESOL = @P_CDFILIAL
              AND DTRESEMBARQ = @P_DTLEVINI
              AND EXISTS (SELECT 1
                          FROM RELACPRODOL
                          WHERE RELACPRODOL.CDPRODARVOL = @V_AFPEND_CDPRODESTO
                            AND RELACPRODOL.CDPRARVORIG = RESERVAPEDEXOL.CDPRODUTO
                            AND RELACPRODOL.CDMARCA     = RESERVAPEDEXOL.CDMARCA);

            IF (@V_RESERVAESTOQUE IS NULL) BEGIN
               SET @V_RESERVAESTOQUE = 0;
            END;*/

            SET @V_QTESTOQUE = @V_QTESTOQUE + @V_ESTOQFILI - @V_RESERVAESTOQUE;
         END;
         INSERT INTO TRAB_ESTPROJET
            (CDFILESTPROJ,
             NRSEQESTPROJ,
             CDPROESTPROJ,
             QTPRODESTOQ,
             QTPRODSOLI,
             QTPROJESTPRO,
             DTENTESTPROJ)
         VALUES
            (@P_CDFILIAL,
             SUBSTRING(@V_NRESTPROJET,11,10),
             @V_AFPEND_CDPRODESTO,
             ISNULL(@V_QTESTOQUE, 0),
             @V_PEDIDO_QTPEDIDO,
             ISNULL(@V_QTESTOQUE, 0) - @V_PEDIDO_QTPEDIDO,
             @P_DTLEVINI);
      END;
      FETCH NEXT FROM C_PEDIDOOLPEND INTO @V_PEDIDO_CDPRODESTO, @V_PEDIDO_QTPEDIDO;
   END;
   CLOSE C_PEDIDOOLPEND;
   DEALLOCATE C_PEDIDOOLPEND;

   DECLARE C_DATA CURSOR FOR /* Seleciona as Datas do Perodo Informado */
     SELECT
         DTDATA
      FROM
         DATA
      WHERE
         DTDATA BETWEEN @P_DTLEVINI+1 AND @P_DTLEVFIN;
   OPEN C_DATA;
   FETCH NEXT FROM C_DATA INTO @V_DATA_DTDATA;
   WHILE (@@FETCH_STATUS = 0)
   BEGIN
      /* Entrada de Produto do OL -  Autorizao de Fornecimento */
      DECLARE C_ITEMAUTF CURSOR FOR
         SELECT
            PRODUTO.CDPRODESTO,
            ISNULL(SUM((QTPROGENTAF - ISNULL(QTEFETENTRAF,0)) * PRODUTO.VRFATOCONV), 0) QTPROGENTAF
         FROM
            PRODUTO,
            ITEMAUTF
         WHERE ITEMAUTF.CDFILDEST = @P_CDFILIAL
           AND ITEMAUTF.DTPROGENTAF = @V_DATA_DTDATA
           AND PRODUTO.CDARVPROD  BETWEEN @P_PRODINI  AND @P_PRODFIN
           AND (ITEMAUTF.IDBAIXITMAF IS NULL OR ITEMAUTF.IDBAIXITMAF = '1')
           AND ITEMAUTF.CDPRODUTO = PRODUTO.CDPRODUTO
           AND NOT EXISTS
                  (SELECT
                      '1'
                   FROM
                      AUTOFORNE
                   WHERE AUTOFORNE.CDFILLANC = ITEMAUTF.CDFILLANC
                     AND AUTOFORNE.CDFILDEST = ITEMAUTF.CDFILDEST
                     AND AUTOFORNE.NRAUTOFORN = ITEMAUTF.NRAUTOFORN
                     AND AUTOFORNE.IDBAIXAAF IN('4','5','6'))
         GROUP BY
            PRODUTO.CDPRODESTO;
      OPEN C_ITEMAUTF;
      FETCH NEXT FROM C_ITEMAUTF INTO @V_ITEMAUTF_CDPRODESTO, @V_ITEMAUTF_QTPROGENTAF;
      WHILE (@@FETCH_STATUS = 0)
      BEGIN
         SET @V_QTESTOQUE      = 0;
         SET @V_ESTOQFILI      = 0;
         SET @V_QTESTOQANT     = 0;
         SET @V_RESERVAESTOQUE = 0;
         UPDATE TRAB_ESTPROJET
            SET QTPRODLANCAF = ISNULL(QTPRODLANCAF, 0) + @V_ITEMAUTF_QTPROGENTAF,
                QTPROJESTPRO = ISNULL(QTPROJESTPRO, 0) + @V_ITEMAUTF_QTPROGENTAF
         WHERE
            CDFILESTPROJ = @P_CDFILIAL                  AND
            NRSEQESTPROJ = SUBSTRING(@V_NRESTPROJET,11,10) AND
            CDPROESTPROJ = @V_ITEMAUTF_CDPRODESTO       AND
            DTENTESTPROJ = @V_DATA_DTDATA;
         IF (@@ROWCOUNT = 0) BEGIN
            SELECT
               @V_QTESTOQANT = MAX(QTPROJESTPRO)
            FROM
               TRAB_ESTPROJET
            WHERE
               CDFILESTPROJ = @P_CDFILIAL                   AND
               NRSEQESTPROJ = SUBSTRING(@V_NRESTPROJET,11,10)  AND
               CDPROESTPROJ = @V_ITEMAUTF_CDPRODESTO        AND
               DTENTESTPROJ = @V_DATA_DTDATA - 1;
            IF @V_QTESTOQANT IS NOT NULL BEGIN
               SET @V_QTESTOQUE = @V_QTESTOQUE + @V_QTESTOQANT;
            END
            ELSE BEGIN
               OPEN C_FILIAL;
               FETCH NEXT FROM C_FILIAL INTO @V_FILIAL_CDFILIAL;
               WHILE (@@FETCH_STATUS = 0)
               BEGIN
                 SET @V_ESTOQFILI = 0;
                 SET @V_ESTOQFILI = TEKNISA.CALC_ESTOQ_CONS(@V_FILIAL_CDFILIAL, @V_AFPEND_CDPRODESTO, @V_DATA_DTDATA+1);

/*               SELECT
                    @V_RESERVAESTOQUE = SUM(QTRESERVESTOL)
                 FROM
                    RESERVAPEDEXOL
                 WHERE CDFILRESOL = @P_CDFILIAL
                   AND DTRESEMBARQ = @V_DATA_DTDATA
                   AND EXISTS (SELECT 1
                               FROM RELACPRODOL
                               WHERE RELACPRODOL.CDPRODARVOL = @V_AFPEND_CDPRODESTO
                                 AND RELACPRODOL.CDPRARVORIG = RESERVAPEDEXOL.CDPRODUTO
                                 AND RELACPRODOL.CDMARCA     = RESERVAPEDEXOL.CDMARCA);

                 IF (@V_RESERVAESTOQUE IS NULL) BEGIN
                    SET @V_RESERVAESTOQUE = 0;
                 END;*/

                 SET @V_QTESTOQUE = @V_QTESTOQUE + @V_ESTOQFILI - @V_RESERVAESTOQUE;
                 FETCH NEXT FROM C_FILIAL INTO @V_FILIAL_CDFILIAL;
               END;
               CLOSE C_FILIAL;
            END;
            INSERT INTO TRAB_ESTPROJET
               (CDFILESTPROJ,
                NRSEQESTPROJ,
                CDPROESTPROJ,
                QTPRODESTOQ,
                QTPRODLANCAF,
                QTPROJESTPRO,
                DTENTESTPROJ)
            VALUES
               (@P_CDFILIAL,
                SUBSTRING(@V_NRESTPROJET,11,10),
                @V_ITEMAUTF_CDPRODESTO,
                ISNULL(@V_QTESTOQUE, 0),
                @V_ITEMAUTF_QTPROGENTAF,
                ISNULL(@V_QTESTOQUE, 0) + @V_ITEMAUTF_QTPROGENTAF,
                @V_DATA_DTDATA);
         END;
         FETCH NEXT FROM C_ITEMAUTF INTO @V_ITEMAUTF_CDPRODESTO, @V_ITEMAUTF_QTPROGENTAF;
      END;
      CLOSE C_ITEMAUTF;
      DEALLOCATE C_ITEMAUTF;

      /* Sada do OL -  AF's das Unidades */
      DECLARE C_SAIDA CURSOR FOR
         SELECT
            PRODUTO.CDPRODESTO,
            SUM(ISNULL(ITEMPEDEXOL.QTATENDPEDOL, ITEMPEDEXOL.QTPROGENPEOL)* PRODUTO.VRFATOCONV) QTAENTREGAR
         FROM
            ITEMPEDEXOL,
            PEDIDOEXOL,
            PRODUTO,
            RELACPRODOL
         WHERE ITEMPEDEXOL.CDFILDEST     = PEDIDOEXOL.CDFILDEST
           AND ITEMPEDEXOL.CDFILLANC     = PEDIDOEXOL.CDFILLANC
           AND ITEMPEDEXOL.NRPEDEXOL     = PEDIDOEXOL.NRPEDEXOL
           AND ISNULL(PEDIDOEXOL.IDBAIXEXOL, '0') NOT IN ('4', '5')
           AND ITEMPEDEXOL.IDBAIXAOLSAI IS NULL
           AND PEDIDOEXOL.CDFILIOPELOG   = @P_CDFILIAL
           AND PRODUTO.CDARVPROD  BETWEEN  @P_PRODINI  AND @P_PRODFIN
           AND RELACPRODOL.CDPRODARVOL   = PRODUTO.CDPRODUTO
           AND ITEMPEDEXOL.CDMARCA       = RELACPRODOL.CDMARCA
           AND ITEMPEDEXOL.CDPRODUTO     = RELACPRODOL.CDPRARVORIG
           AND ITEMPEDEXOL.DTPROGEMBARQ  = @V_DATA_DTDATA
         GROUP BY
            PRODUTO.CDPRODESTO;
      OPEN C_SAIDA;
      FETCH NEXT FROM C_SAIDA INTO @V_SAIDA_CDPRODESTO, @V_SAIDA_QTAENTREGAR;
      WHILE (@@FETCH_STATUS = 0)
      BEGIN
         SET @V_QTESTOQUE      = 0;
         SET @V_ESTOQFILI      = 0;
         SET @V_QTESTOQANT     = 0;
         SET @V_RESERVAESTOQUE = 0;
         IF @V_SAIDA_QTAENTREGAR > 0 BEGIN
            UPDATE TRAB_ESTPROJET
               SET QTPRODSOLI   = ISNULL(QTPRODSOLI, 0) + @V_SAIDA_QTAENTREGAR,
                   QTPROJESTPRO = ISNULL(QTPROJESTPRO, 0) - @V_SAIDA_QTAENTREGAR
            WHERE
               CDFILESTPROJ = @P_CDFILIAL                     AND
               NRSEQESTPROJ = SUBSTRING(@V_NRESTPROJET,11,10) AND
               CDPROESTPROJ = @V_SAIDA_CDPRODESTO              AND
               DTENTESTPROJ = @V_DATA_DTDATA;
            IF (@@ROWCOUNT = 0) BEGIN
               SELECT
                  @V_QTESTOQANT = MAX(QTPROJESTPRO)
               FROM
                  TRAB_ESTPROJET
               WHERE
                  CDFILESTPROJ = @P_CDFILIAL                   AND
                  NRSEQESTPROJ = SUBSTRING(@V_NRESTPROJET,11,10)  AND
                  CDPROESTPROJ = @V_SAIDA_CDPRODESTO        AND
                  DTENTESTPROJ = @V_DATA_DTDATA - 1;
               IF @V_QTESTOQANT IS NOT NULL BEGIN
                  SET @V_QTESTOQUE = @V_QTESTOQUE + @V_QTESTOQANT;
               END
               ELSE BEGIN
                  OPEN C_FILIAL;
                  FETCH NEXT FROM C_FILIAL INTO @V_FILIAL_CDFILIAL;
                  WHILE (@@FETCH_STATUS = 0)
                  BEGIN
                     SET @V_ESTOQFILI = 0;
                     SET @V_ESTOQFILI = TEKNISA.CALC_ESTOQ_CONS(@V_FILIAL_CDFILIAL, @V_SAIDA_CDPRODESTO, @V_DATA_DTDATA+1);

/*                   SELECT
                        @V_RESERVAESTOQUE = SUM(QTRESERVESTOL)
                     FROM
                        RESERVAPEDEXOL
                     WHERE CDFILRESOL = @P_CDFILIAL
                       AND DTRESEMBARQ = @V_DATA_DTDATA
                       AND EXISTS (SELECT 1
                                   FROM RELACPRODOL
                                   WHERE RELACPRODOL.CDPRODARVOL = @V_SAIDA_CDPRODESTO
                                     AND RELACPRODOL.CDPRARVORIG = RESERVAPEDEXOL.CDPRODUTO
                                     AND RELACPRODOL.CDMARCA     = RESERVAPEDEXOL.CDMARCA);

                     IF (@V_RESERVAESTOQUE IS NULL) BEGIN
                        SET @V_RESERVAESTOQUE = 0;
                     END;*/

                     SET @V_QTESTOQUE = @V_QTESTOQUE + @V_ESTOQFILI - @V_RESERVAESTOQUE;
                     FETCH NEXT FROM C_FILIAL INTO @V_FILIAL_CDFILIAL;
                  END;
                  CLOSE C_FILIAL;
               END;
               INSERT INTO TRAB_ESTPROJET
                  (CDFILESTPROJ,
                   NRSEQESTPROJ,
                   CDPROESTPROJ,
                   QTPRODESTOQ,
                   QTPRODSOLI,
                   QTPROJESTPRO,
                   DTENTESTPROJ)
               VALUES
                  (@P_CDFILIAL,
                   SUBSTRING(@V_NRESTPROJET,11,10),
                   @V_SAIDA_CDPRODESTO,
                   ISNULL(@V_QTESTOQUE, 0),
                   @V_SAIDA_QTAENTREGAR,
                   ISNULL(@V_QTESTOQUE, 0) - @V_SAIDA_QTAENTREGAR,
                   @V_DATA_DTDATA);
            END;
         END;
         FETCH NEXT FROM C_SAIDA INTO @V_SAIDA_CDPRODESTO, @V_SAIDA_QTAENTREGAR;
      END;
      CLOSE C_SAIDA;
      DEALLOCATE C_SAIDA;
      DECLARE C_PROD CURSOR FOR
         SELECT
             CDFILESTPROJ,
             NRSEQESTPROJ,
             CDPROESTPROJ,
             MAX(DTENTESTPROJ) DTENTESTPROJ
          FROM
             TRAB_ESTPROJET
          WHERE
             CDFILESTPROJ = @P_CDFILIAL                   AND
             NRSEQESTPROJ = SUBSTRING(@V_NRESTPROJET,11,10)  AND
             DTENTESTPROJ <= @V_DATA_DTDATA
          GROUP BY
             CDFILESTPROJ,
             NRSEQESTPROJ,
             CDPROESTPROJ;
      OPEN C_PROD;
      FETCH NEXT FROM C_PROD INTO @V_PROD_CDFILESTPROJ, @V_PROD_NRSEQESTPROJ,
                                  @V_PROD_CDPROESTPROJ, @V_PROD_DTENTESTPROJ
      WHILE (@@FETCH_STATUS = 0)
      BEGIN
         IF @V_DATA_DTDATA <> @V_PROD_DTENTESTPROJ BEGIN
            SELECT
               @V_QTPROJESTPRO = MAX(QTPROJESTPRO)
            FROM
               TRAB_ESTPROJET
            WHERE
               CDFILESTPROJ = @P_CDFILIAL                      AND
               NRSEQESTPROJ = SUBSTRING(@V_NRESTPROJET,11,10)  AND
               CDPROESTPROJ = @V_PROD_CDPROESTPROJ              AND
               DTENTESTPROJ = @V_PROD_DTENTESTPROJ;
            
            IF @V_VDOL <> 'O' BEGIN    
               SELECT @V_QTDAF = ISNULL(SUM(ITF.QTPROGENTAF), 0)
               FROM ITEMAUTF ITF, PRODUTO P
               WHERE ITF.CDPRODUTO   = P.CDPRODUTO
                 AND P.CDPRODESTO    = @V_PROD_CDPROESTPROJ  
                 AND ITF.CDFILDEST   = @P_CDFILIAL
                 AND ITF.DTPROGENTAF = @V_DATA_DTDATA;
            
               SELECT @V_QTDSOL = ISNULL(SUM(ITS.QTSOLIPROD), 0)
               FROM ITEMSOLI ITS, PRODUTO PR
               WHERE ITS.CDPRODUTO  = PR.CDPRODUTO
                 AND PR.CDPRODESTO  = @V_PROD_CDPROESTPROJ  
                 AND ITS.CDFILSOLI  = @P_CDFILIAL 
                 AND ITS.DTPROGENTR = @V_DATA_DTDATA;
               
               SET @V_QTPROJESTPRO = @V_QTPROJESTPRO + @V_QTDAF - @V_QTDSOL;
            END;
            INSERT INTO TRAB_ESTPROJET
               (CDFILESTPROJ,
                NRSEQESTPROJ,
                CDPROESTPROJ,
                QTPRODESTOQ,
                QTPROJESTPRO,
                DTENTESTPROJ,
                QTDIRESUPRAF,
                QTPRODSOLI
                )
            VALUES
               (@V_PROD_CDFILESTPROJ,
                @V_PROD_NRSEQESTPROJ,
                @V_PROD_CDPROESTPROJ,
                @V_QTPROJESTPRO,
                @V_QTPROJESTPRO,
                @V_DATA_DTDATA,
                @V_QTDAF,
                @V_QTDSOL);
         END;
         FETCH NEXT FROM C_PROD INTO @V_PROD_CDFILESTPROJ, @V_PROD_NRSEQESTPROJ,
                                     @V_PROD_CDPROESTPROJ, @V_PROD_DTENTESTPROJ
      END;
      CLOSE C_PROD;
      DEALLOCATE C_PROD;
      FETCH NEXT FROM C_DATA INTO @V_DATA_DTDATA;
   END;
   CLOSE C_DATA;
   DEALLOCATE C_DATA;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'PROJETA_ESTOQUE_DIA','6.05.xxx';
GO

