INSERT INTO HISTALTERADFE(CDPROCESSO, CDNOTATECNICA, CDVERSAONT, DSHISTORICO, DTINIVIGENCIAPROD, DTINIVIGENCIAHOMO)
VALUES ('NF', '2023001', '1.20', 'Tributao Monofsica sobre Combustveis', '20/04/2023', '01/05/2023')
/

COMMIT
/

INSERT INTO PARAMCST 
   (IDENTRSAIDOP, CDIMPOSTO, CDSITUTRIB, DSSITUTRIB, IDUTITIPCREDITO)
VALUES
   ('E', '00', '02', 'Tributao monofsica prpria sobre combustveis', 'N')
/

INSERT INTO PARAMCST 
   (IDENTRSAIDOP, CDIMPOSTO, CDSITUTRIB, DSSITUTRIB, IDUTITIPCREDITO)
VALUES
   ('E', '00', '15', 'Tributao monofsica prpria e com responsabilidade pela reteno sobre combustveis', 'N')
/

INSERT INTO PARAMCST 
   (IDENTRSAIDOP, CDIMPOSTO, CDSITUTRIB, DSSITUTRIB, IDUTITIPCREDITO)
VALUES
   ('E', '00', '53', 'Tributao monofsica sobre combustveis com recolhimento diferido', 'N')
/

INSERT INTO PARAMCST 
   (IDENTRSAIDOP, CDIMPOSTO, CDSITUTRIB, DSSITUTRIB, IDUTITIPCREDITO)
VALUES
   ('E', '00', '61', 'Tributao monofsica sobre combustveis cobrada anteriormente', 'N')
/

INSERT INTO PARAMCST 
   (IDENTRSAIDOP, CDIMPOSTO, CDSITUTRIB, DSSITUTRIB, IDUTITIPCREDITO)
VALUES
   ('S', '00', '02', 'Tributao monofsica prpria sobre combustveis', 'N')
/

INSERT INTO PARAMCST 
   (IDENTRSAIDOP, CDIMPOSTO, CDSITUTRIB, DSSITUTRIB, IDUTITIPCREDITO)
VALUES
   ('S', '00', '15', 'Tributao monofsica prpria e com responsabilidade pela reteno sobre combustveis', 'N')
/

INSERT INTO PARAMCST 
   (IDENTRSAIDOP, CDIMPOSTO, CDSITUTRIB, DSSITUTRIB, IDUTITIPCREDITO)
VALUES
   ('S', '00', '53', 'Tributao monofsica sobre combustveis com recolhimento diferido', 'N')
/

INSERT INTO PARAMCST 
   (IDENTRSAIDOP, CDIMPOSTO, CDSITUTRIB, DSSITUTRIB, IDUTITIPCREDITO)
VALUES
   ('S', '00', '61', 'Tributao monofsica sobre combustveis cobrada anteriormente', 'N')
/

COMMIT
/

ALTER TABLE DETESPCOMBNFE ADD VRPERCINDICE FLOAT
/

CREATE TABLE ORIGCOMBNFE 
(
   CDFILIAL        	 VARCHAR2(04) NOT NULL,
   NRLANCTONF      	 VARCHAR2(10) NOT NULL,
   NRSEQITPROD     	 VARCHAR2(04) NOT NULL,
   NRSEQORIGCOMB   	 VARCHAR2(02) NOT NULL,
   SGESTADOORIG    	 VARCHAR2(02) NULL,
   IDIMPORTACAO    	 VARCHAR2(01) NULL,
   VRPERCORIGUF    	 FLOAT        NULL,
   NRORG             NUMBER 	      DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg') 		NOT NULL,
   IDATIVO           VARCHAR2(1)     DEFAULT 'S'					NOT NULL,
   DTINCLUSAO        DATE            DEFAULT SYSDATE,
   DTULTATU          DATE            DEFAULT SYSDATE,
   NRORGINCLUSAO     NUMBER          DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg')		NULL,
   CDOPERINCLUSAO    VARCHAR2(12)    DEFAULT '1' 					NULL,
   NRORGULTATU       NUMBER          DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg')		NULL,
   CDOPERULTATU      VARCHAR2(12)    DEFAULT '1',
		CONSTRAINT CKC_IDATIVO_ORIGCOMBNFE CHECK (IDATIVO IN ('S','N')),
		CONSTRAINT PK_ORIGCOMBNFE PRIMARY KEY (CDFILIAL, NRLANCTONF, NRSEQITPROD, NRSEQORIGCOMB)
)
/

ALTER TABLE ORIGCOMBNFE ADD CONSTRAINT FKFIS00899DETESPCO FOREIGN KEY (CDFILIAL, NRLANCTONF, NRSEQITPROD)
       REFERENCES DETESPCOMBNFE (CDFILIAL, NRLANCTONF, NRSEQITPROD) ON DELETE CASCADE
/

CREATE INDEX FIS00898_FK ON ORIGCOMBNFE (CDFILIAL ASC, NRLANCTONF ASC, NRSEQITPROD ASC)
/

ALTER TABLE PRODUTO ADD VRPERCMISTURA FLOAT
/

ALTER TABLE PRODUTO ADD VRALIQICMSMONO FLOAT
/

ALTER TABLE PRODUTO ADD VRALIQICMSMONORET FLOAT
/

ALTER TABLE PRODUTO ADD IDMOTREDBCICMSMONO VARCHAR2(1)
/

ALTER TABLE ITEMPROIMPOS ADD VRBCMONORET FLOAT
/

ALTER TABLE ITEMPROIMPOS ADD VRALIQMONORET FLOAT
/

ALTER TABLE ITEMPROIMPOS ADD VRICMSMONORET FLOAT
/

ALTER TABLE ITEMPROIMPOS ADD VRPREDBCICMSMONO FLOAT
/

ALTER TABLE ITEMPROIMPOS ADD IDMOTREDBCICMSMONO VARCHAR2(1)
/

ALTER TABLE ITEMPROIMPOS ADD VRBCMONO FLOAT
/

ALTER TABLE ITEMPROIMPOS ADD VRALIQMONO FLOAT
/

ALTER TABLE ITEMPROIMPOS ADD VRICMSMONO FLOAT
/

ALTER TABLE INTG_TRABITPROIMPOS ADD VRBCMONORET FLOAT
/

ALTER TABLE INTG_TRABITPROIMPOS ADD VRALIQMONORET FLOAT
/

ALTER TABLE INTG_TRABITPROIMPOS ADD VRICMSMONORET FLOAT
/

ALTER TABLE INTG_TRABITPROIMPOS ADD VRPREDBCICMSMONO FLOAT
/

ALTER TABLE INTG_TRABITPROIMPOS ADD IDMOTREDBCICMSMONO VARCHAR2(1)
/

ALTER TABLE INTG_TRABITPROIMPOS ADD VRBCMONO FLOAT
/

ALTER TABLE INTG_TRABITPROIMPOS ADD VRALIQMONO FLOAT
/

ALTER TABLE INTG_TRABITPROIMPOS ADD VRICMSMONO FLOAT
/

ALTER TABLE TRABITPROIMPOS ADD VRBCMONORET FLOAT
/

ALTER TABLE TRABITPROIMPOS ADD VRALIQMONORET FLOAT
/

ALTER TABLE TRABITPROIMPOS ADD VRICMSMONORET FLOAT
/

ALTER TABLE TRABITPROIMPOS ADD VRPREDBCICMSMONO FLOAT
/

ALTER TABLE TRABITPROIMPOS ADD IDMOTREDBCICMSMONO VARCHAR2(1)
/

ALTER TABLE TRABITPROIMPOS ADD VRBCMONO FLOAT
/

ALTER TABLE TRABITPROIMPOS ADD VRALIQMONO FLOAT
/

ALTER TABLE TRABITPROIMPOS ADD VRICMSMONO FLOAT
/